<template>
  <div class="header-wrapper" :class="{ 'show': isShowSideBar, 'dark-modify': isPageActive('dashboard') }" v-click-outside="closeSideBar">
    <!-- header desktop -->
    <div class="main-header-01" :class="{'hide': isHideHeader}">
      <div class="wrapper-content">
        <a href="/" class="logo">
         <img :src="logoSrc" alt="logo"/>
        </a>

      <div class="trigger-mobile" :class="{'active': isShowSideBar}" @click="toggleSideBar">
        <span></span>
      </div>

        <nav class="menu-desktop">
          <ul class="menu">
            <li class="item" :class="{'active': isPageActive('dashboard')}">
              <router-link class="link" to="/dashboard">{{$t('header.txt1')}}</router-link>
            </li>

            <li class="item fund" :class="{'highLight': isPageActive('balances') || isPageActive('deposit') || isPageActive('wallet/transactions') || isPageActive('token-history'), 'active': isShowFund}"  @click="toggleFundList" v-click-outside="closeFundList">
              <a href="javascript:void(0)" class="link">{{$t('header.txt2')}}</a>
              <i class="fa fa-caret-down fund__arrow" aria-hidden="true"></i>
              <div class="sub-menu">
                <router-link to="/balances" class="list-item" :class="{'active': isPageActive('balance')}">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{$t('header.txt3')}}
                </router-link>
                <router-link to="/token-history" class="list-item" :class="{'active': isPageActive('token-history')}">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{$t('header.txt10')}}
                </router-link>
                <router-link to="/deposit" class="list-item" :class="{'active': isPageActive('deposit')}">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{$t('header.txt4')}}
                </router-link>
                <router-link to="/wallet/transactions" class="list-item" :class="{'active': isPageActive('wallet/transactions')}">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{$t('header.txt5')}}
                </router-link>
              </div>
            </li>

            <li class="item" :class="{'active': isPageActive('bounty')}">
              <router-link class="link" to="/bounty">{{$t('header.txt6')}}</router-link>
            </li>

            <li class="item" :class="{'active': isPageActive('faq')}">
              <router-link class="link" to="/faq">{{$t('header.txt7')}}</router-link>
            </li>

            <li class="item account" :class="{'active': isShowProfile}" @click="toggleProfile" v-click-outside="closeProfile">
              <a href="#" class="link email">{{ user.email }}</a>
              <i class="fa fa-caret-down account-arrow" aria-hidden="true"></i>
              <div class="sub-menu">
                <div class="list-item heta-infor">
                  <span class="heta__value">{{ hetaTokensWallet.balance | formatCurrencyAmount('heta', '0') }}</span>
                  <span >Heta Token</span>
                </div>
                <router-link to="/users/profileSetting" class="list-item">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{$t('header.txt8')}}
                </router-link>
                <router-link to="/users/kyc" class="list-item" v-if="!!user">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{$t('header.txt9')}}
                  <span :class="kycStatus" class="kyc_status">{{ kycStatus }}</span>
                </router-link>
                <router-link to="/guide" class="list-item" v-if="!!user">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{ $t('header.txt11') }}
                </router-link>
                <a class="list-item logout" @click="$refs.logoutForm.submit()">
                  <i class="fa fa-angle-right" aria-hidden="true"></i>
                  {{ $t('header.logout') }}
                </a>
                <form :action="`${$baseUrl}/logout`" ref="logoutForm" style="display: none" method="post">
                  <input type="hidden" name="_token" :value="$csrfToken">
                </form>
              </div>
            </li>

            <li class="item language" @click="toggleLanguageList" :class="{'active': isShowLanguage}" v-click-outside="closeLanguage">
              <div class="language__current">
                <span>{{ $i18n.locale | uppercase }}</span>
                <i class="fa fa-caret-down language__arrow" aria-hidden="true"></i>
              </div>

              <ul class="language-list sub-menu">
                <template v-for="locale in supportedLocales">
                  <li v-if="$i18n.locale !== locale"
                      class="list-item"
                      @click="updateUserLocale(locale)">
                    <span>{{ locale | uppercase }}</span>
                  </li>
                </template>
              </ul>
            </li>
          </ul>
        </nav>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState, mapGetters } from 'vuex';
import rf from '../../../common/requests/RequestFactory';
import Utils from '../../../common/utils';

export default {
  data () {
    return {
      isShowSideBar: false,
      isShowProfile: false,
      listKycStatus: [ 'unverified', 'pending', 'verified', 'rejected'],
      isShowLanguage: false,
      isShowFund: false,
      isHideHeader: false,
      isFixedHeader: false,
      logoSrc: "/images/hetachain_headerlogo.png",
    }
  },
  watch: {
      user() {
        this.supportAccountWidth();
      }
  },
  computed: {
    ...mapGetters(['hetaTokensWallet']),
    ...mapState([
      'user',
      'supportedLocales',
    ]),
    kycStatus() {
      if (!this.listKycStatus[this.user.kyc_status]) {
        return '';
      }

      return this.listKycStatus[this.user.kyc_status];
    }
  },
  methods: {
    toggleProfile () {
      this.isShowProfile = !this.isShowProfile;
    },
    closeSideBar () {
      if (this.isShowSideBar) {
        this.toggleSideBar();
      }
    },
    toggleSideBar () {
      this.isShowSideBar = !this.isShowSideBar;
    this.$broadcast('toggleSideBar');
    },
    closeProfile () {
      this.isShowProfile = false;
    },
    closeLanguage () {
      if (this.isShowLanguage) {
        this.toggleLanguageList();
      }
    },
    closeFundList () {
      if (this.isShowFund) {
        this.toggleFundList();
      }
    },
    toggleLanguageList () {
      this.isShowLanguage = !this.isShowLanguage;
    },
    toggleFundList () {
      this.isShowFund = !this.isShowFund;
    },
    isPageActive (routeName) {
      const reg = new RegExp(`/${routeName}`);
      return reg.test(this.$route.path);
    },
    updateUserLocale(locale){
      Utils.setI18nLocale(locale);
      document.documentElement.setAttribute('lang', locale);

      let params = {
        lang: locale
      };
      rf.getRequest('UserRequest').setLocale(params);
    },

    handleScroll() {
      if ( window.pageYOffset > 104 ) {
        if ( window.pageYOffset > (this.currentOffsetTop) ) {
          // scrollDown
          this.isHideHeader = true;
        } else {
          // scrollTop
          this.isHideHeader = false;
        }
      }
      this.currentOffsetTop = window.pageYOffset;
      if (window.pageYOffset === 0) {
        this.isHideHeader = false;
      }
    },
    supportAccountWidth () {
       jQuery(document).ready(function($) {
        let t = $('.menu').width(),
            t2 = $('.logo').width(),
            t3 = $('.main-header-01 .wrapper-content').width(),
            currentWidth = $('.link.email').outerWidth();
        $('.link.email').css({maxWidth: t3 - t - t2 + currentWidth});
      });
    }
  },
  created() {
    this.$nextTick(() => {
      this.supportAccountWidth();
    });

    window.addEventListener('scroll', this.handleScroll);
    if (window.innerWidth < 1200 ) {
      this.logoSrc = "/images/logo-HETA2.png";
    }
  }
}
</script>
<style scoped lang="scss">
@import '../../../../sass/vendor/position';
  .header-wrapper {
    transition: all 0.3s ease-in-out;
    min-height: 95px;

    &.dark-modify {
      background-color: #181a3a;
    }

    &.show {
      transform: translateX(-240px);
    }

    .hide {
      transform: translateY(-100%);
    }

    .main-header-01 {
      transition: all 0.3s ease-in-out;
      @include fixed(0, 0 ,auto, 0);
      z-index: 1000;
    }
  }
  .kyc_status {
    color: #4a90e2;
    &.pending {
      color: #4caf50;
    }
    &.verified {
      color: #fa7300;
    }
    &.rejected {
      color: #d0021b;
    }
  }
  .heta-infor {
    cursor: default;
  }
  .sub-menu {
    text-align: left !important;
  }
  .fa-angle-right {
    padding-right: 0.5rem;
  }
  .link.email {
    display: inline-block;
    vertical-align: middle;
    line-height: 16px;
    max-width: 250px;
    overflow: hidden;
    text-overflow: ellipsis;
    @media screen and (max-width: 1100px){
      max-width: 200px;
    }
  }
</style>
